import { Component } from 'react';
import type { TruncateListProps, TruncateListState } from './props';
/**
---
category: components/utilities
---
**/
declare class TruncateList extends Component<TruncateListProps, TruncateListState> {
    static readonly componentId = "TruncateList";
    static propTypes: import("@instructure/shared-types").PropValidators<keyof {
        children?: React.ReactNode;
        visibleItemsCount?: number;
        renderHiddenItemMenu?: (hiddenChildren: Exclude<React.ReactNode, boolean | null | undefined>[]) => React.ReactElement;
        onUpdate?: (visibleItemsCount: {
            visibleItemsCount: number;
        }) => void;
        itemSpacing?: string;
        fixMenuTriggerWidth?: string;
        debounce?: number;
        elementRef?: (element: HTMLUListElement | null) => void;
    }>;
    static allowedProps: readonly (keyof {
        children?: React.ReactNode;
        visibleItemsCount?: number;
        renderHiddenItemMenu?: (hiddenChildren: Exclude<React.ReactNode, boolean | null | undefined>[]) => React.ReactElement;
        onUpdate?: (visibleItemsCount: {
            visibleItemsCount: number;
        }) => void;
        itemSpacing?: string;
        fixMenuTriggerWidth?: string;
        debounce?: number;
        elementRef?: (element: HTMLUListElement | null) => void;
    })[];
    static defaultProps: {
        itemSpacing: string;
        debounce: number;
    };
    ref: HTMLUListElement | null;
    private _menuTriggerRef;
    private _debouncedHandleResize?;
    private _resizeListener?;
    handleRef: (el: HTMLUListElement | null) => void;
    constructor(props: TruncateListProps);
    componentDidMount(): void;
    componentDidUpdate(prevProps: TruncateListProps, prevState: TruncateListState): void;
    componentWillUnmount(): void;
    get childrenArray(): (string | number | import("react").ReactElement<any, string | import("react").JSXElementConstructor<any>> | Iterable<import("react").ReactNode> | import("react").ReactPortal)[];
    get visibleChildren(): (string | number | import("react").ReactElement<any, string | import("react").JSXElementConstructor<any>> | Iterable<import("react").ReactNode> | import("react").ReactPortal)[];
    get hiddenChildren(): (string | number | import("react").ReactElement<any, string | import("react").JSXElementConstructor<any>> | Iterable<import("react").ReactNode> | import("react").ReactPortal)[];
    calcMenuTriggerWidth(): number;
    measureItems: () => {
        visibleItemsCount: number;
    };
    handleResize: () => void;
    render(): import("@emotion/react/jsx-runtime").JSX.Element;
}
export { TruncateList };
export default TruncateList;
//# sourceMappingURL=index.d.ts.map